<?php

class Minimax_Partialindex_Model_Observer
{

    public function addProductReindex(Varien_Event_Observer $observer)
    {
        $product = $observer->getEvent()->getProduct();
		
		if($product){
			$productId = $product->getId();
			$catalogProductPartialindex = Mage::getSingleton('core/resource')->getTableName('catalog_product_partialindex');
			$write = Mage::getSingleton('core/resource')->getConnection('core_write');
			
			// Permet de ne pas insérer la ligne si le product_id est déjà existant
			$sql = "INSERT INTO {$catalogProductPartialindex} (product_id)
				SELECT * FROM (SELECT '{$productId}') AS tmp
				WHERE NOT EXISTS (
					SELECT product_id FROM {$catalogProductPartialindex} WHERE product_id = '{$productId}'
				) LIMIT 1;";
			Mage::log($sql,null,'requete.log',true);
			$write->query($sql);
		}
		
        return;
    }
	
	public function emptyPartialIndex(Varien_Event_Observer $observer)
    {
       
		$catalogProductPartialindex = Mage::getSingleton('core/resource')->getTableName('catalog_product_partialindex');
		$write = Mage::getSingleton('core/resource')->getConnection('core_write');
		
		// On vide la table si le flat est réindexé complètement.
		$sql = "TRUNCATE TABLE {$catalogProductPartialindex};";

		$write->query($sql);
		
        return;
    }

	public function launchPartialReindex(){
		$isActive = (int) Mage::getStoreConfig('minimax_partialindex/index/isActive');
		if($isActive) {
			$process = Mage::getSingleton('index/indexer')->getProcessByCode("partialindex_product");
			$process->reindexEverything();
		}
		
		return;
	}
	
	public function cleanPartialIndex(Varien_Event_Observer $observer)
    {
		$entityIds = $observer->getEvent()->getEntityId();
		if(!empty($entityIds)){
			$catalogProductPartialindex = Mage::getSingleton('core/resource')->getTableName('catalog_product_partialindex');
			$write = Mage::getSingleton('core/resource')->getConnection('core_write');
			
			// On retire les produits traités de la table si tout est réindexé correctement.
			$sql = "DELETE FROM {$catalogProductPartialindex} WHERE product_id IN (".implode(',',$entityIds).")";

			$write->query($sql);
		}
        return;
    }
}